rules:
  - id: broadcast-message-class-haml
    pattern-either:
      - pattern: .gl-broadcast-message
      - pattern: .broadcast-banner-message
      - pattern: .broadcast-message
      - pattern: .broadcast-notification-message
    message: |
      Detected usage of broadcast message class(es). Please implement/use the
      Pajamas::BroadcastMessage ViewComponent instead.
    languages:
      - generic
    severity: ERROR
    paths:
      include:
        - '*.haml'
      exclude:
        - app/components/pajamas/broadcast_banner_component.html.haml
        # TODO: Remove if/when this partial uses a ViewComponent or similar.
        - app/views/shared/_broadcast_message.html.haml
    metadata:
      componentLabel: 'component:broadcast-message'
      pajamasCompliant: false
      epic: 'https://gitlab.com/gitlab-org/gitlab/-/issues/362737'

  # TODO: Remove if/when this partial uses a ViewComponent or similar.
  - id: broadcast-message-partial-haml-rb
    pattern-regex: render\b.*shared/broadcast_message
    message: |
      Detected usage of broadcast message partial. Please implement/use the
      Pajamas::BroadcastMessage ViewComponent instead.
    languages:
      - generic
    severity: ERROR
    paths:
      include:
        - '*.haml'
        - '*.rb'
    metadata:
      componentLabel: 'component:broadcast-message'
      pajamasCompliant: false
      epic: 'https://gitlab.com/gitlab-org/gitlab/-/issues/362737'

  - id: okay-broadcast-message-view-component-haml
    patterns:
      - pattern-regex: Pajamas::BroadcastMessage
    message: Correct usage of Pajamas::BroadcastMessage component.
    languages:
      - generic
    severity: INFO
    paths:
      include:
        - '*.haml'
    metadata:
      componentLabel: 'component:broadcast-message'
      pajamasCompliant: true
